Subject: bug#48193: closed (Re: bug#2910: 23.0.60; Shell-script coloring bug)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 14 Oct 2023 15:03:03 +0000

Your bug report

#26217: Youngsters in charge of emacs vs. basic Bourne shell "for" statement

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
26217: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=26217
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#2910: 23.0.60; Shell-script coloring bug
From: Stefan Monnier <[email-masked]>
To: Mauro Aranda <[email-masked]>
Cc: Martin Vath <[email-masked]>, [email-masked], [email-masked]
Date: Sat, 14 Oct 2023 11:01:40 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

>> I haven't found problems, but I'm suspicious because it seems too easy.
> Welcome to the world of Emacs, where "if it's easy it must be right".

BTW, pushed to `master`, thank you.

        Stefan

Subject: Youngsters in charge of emacs vs. basic Bourne shell "for" statement
From: 積丹尼 Dan Jacobson <[email-masked]>
To: [email-masked]
Date: Mon, 03 May 2021 22:48:16 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

for i do
    true
done
    : This line and the whole rest of the program misindented because emacs shallow knowlege of shell grammar.
    : Test with TAB. Emacs only knows about:
    for i
    do
	true
    done
    : If this was python, well, you would have to have the language change to accomidate emacs.
    : Also if we are colaborating on a big project we cannot just rip up line of other peoples code so
    : they are not misindeted for only us.
    : Yes, some emacs programmers do not know shell grammar and just assume... indeed the word "do" on the
    : first line is not even in a different color. But the word in right here in this line is! Three times!
    : Hmmm, [including this part of] the sh language is, maybe 50 years
    : old. Not something checkbashisms --extra --force --posix has an issue with. It is part
    : of sh, bash, dash, ksh, ...
    : I.e., not something invented before emacs...
    : What could be even older? Well, sh must have been written in C...
    : Yes, I reported this before. But it was closed by programmers who
    : do not know basic Bourne shell "for" statement grammar.
    : emacs-version "27.1"

Indeed, I was just reading in RISKS Digest,

> https://www.wired.com/story/ai-latest-trick-writing-computer-code/

> What fun -- being second-guessed in real time by software that doesn't
> understand my code...